﻿using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;


namespace SQLScriptDumper {
    internal class Program {
        private static string sDirectory = ConfigurationManager.AppSettings["directory"];
        private static void Main(string[] args) {            
            ServerConnection sc = new ServerConnection(ConfigurationManager.AppSettings["servername"], ConfigurationManager.AppSettings["user"], ConfigurationManager.AppSettings["password"]);
            Server server = new Server(sc);
            Database db = server.Databases[ConfigurationManager.AppSettings["database"]];
            System.Console.WriteLine("Process Tables");
            ScriptObjectsToFile(db.Tables);
            foreach (Table t in db.Tables) {
                System.Console.WriteLine("Process Table Triggers ->" + t.Name);
                ScriptObjectsToFile(t.Triggers);
            }
            System.Console.WriteLine("Process DB Triggers");
            ScriptObjectsToFile(db.Triggers);
            System.Console.WriteLine("Process UDA");
            ScriptObjectsToFile(db.UserDefinedAggregates);
            System.Console.WriteLine("Process UDDT");
            ScriptObjectsToFile(db.UserDefinedDataTypes);
            System.Console.WriteLine("Process UDF");
            ScriptObjectsToFile(db.UserDefinedFunctions);
            System.Console.WriteLine("Process UDT");
            ScriptObjectsToFile(db.UserDefinedTypes);
            System.Console.WriteLine("Process Views");
            ScriptObjectsToFile(db.Views);
            //ScriptObjectsToFile(db.ApplicationRoles);
            System.Console.WriteLine("Process Stored Procedures");
            ScriptObjectsToFile(db.StoredProcedures);
        }

        private static void ScriptObjectsToFile(IEnumerable xEnumerable) {
            IEnumerator e = xEnumerable.GetEnumerator();
            while (e.MoveNext()) {
                IScriptable s = (IScriptable) e.Current;
                try {
                    ScriptSchemaObjectBase no = (ScriptSchemaObjectBase) e.Current;
                    if (
                        !(no.Schema.StartsWith("sys", StringComparison.CurrentCultureIgnoreCase) ||
                          no.Schema.StartsWith("[sys]", StringComparison.CurrentCultureIgnoreCase))) {
                        StringCollection sc = s.Script();
                        try {
                            File.Delete( sDirectory + e.Current.GetType() + "." + no.Name);
                            System.Console.WriteLine("Delete -> " + sDirectory + e.Current.GetType() +
                                                     "." + no.Name);
                        } catch (Exception) {}
                        StreamWriter sw =
                            File.AppendText(sDirectory + e.Current.GetType() + "." + no.Name);
                        foreach (string so in sc) {
                            sw.WriteLine(so);
                        }
                        sw.Close();
                        System.Console.WriteLine("Written -> " + sDirectory + e.Current.GetType() + "." +
                                                 no.Name);
                    }
                } catch (Exception ex) {
                    ScriptNameObjectBase no = (ScriptNameObjectBase) e.Current;
                    StringCollection sc = s.Script();
                    try {
                        File.Delete(sDirectory + e.Current.GetType() + "." + no.Name);
                        System.Console.WriteLine("Delete -> " + sDirectory + e.Current.GetType() +
                                                 "." + no.Name);
                    } catch (Exception) {}
                    StreamWriter sw =
                        File.AppendText(sDirectory + e.Current.GetType() + "." + no.Name);
                    foreach (string so in sc) {
                        sw.WriteLine(so);
                    }
                    sw.Close();
                    System.Console.WriteLine("Written -> " + sDirectory + e.Current.GetType() + "." +
                                             no.Name);
                }
            }
        }
    }
}